#!/bin/sh
#
#
. ./proc-helper
#
release_ver="1.9+2020-06-06"
release_patch="1.0.9~202006" # check in proc-helper

echo "*******************************************"
echo "*** Script zum Update der Anpassung der ***"
echo "*** Firmware an Erfordernisse von ffhal ***"
echo "*******************************************"
echo

check=`cat /lib/gluon/release | grep $release_ver`
checkpatch=`cat /lib/gluon/release | grep $release_patch`

if [ "$check" == "" ]
then
  if [ "$checkpatch" == "" ]
  then
   echo "Dieses Patch ist fuer diese Version der Firmware NICHT geeignet!"
   echo
   echo "Bitte eine passende Version herunterladen (falls ueberhaupt ein Patch erforderlich ist) und"
   echo "diese dann ausfuehren ..."
   echo
   exit 1
  fi
#  echo "Dieses Patch kann erneut ausgefuehrt werden."
#  echo
#  echo "Bitte dazu das Kommando update ausfuehren..."
#  echo
#  exit 2
else
  echo "Dieses Patch muss als Basis ausgefuehrt werden."
  echo
  echo "Bitte dazu das Kommando go ausfuehren..."
  echo
  exit 2
fi

###########################################
CONF_MODE=`ip a s | grep 'br-setup'`
# if [ "$CONF_MODE" == "" ]
# then
#   echo "Ausfhrung im Config Mode erforderlich..."
#   echo
#   exit 255
# fi

###########################################
echo "-> grille Stuttgarter scripts noch mal..."
###########################################
grill_stuttgart
echo

###########################################
echo "-> frische Config-Vorgaben fuer ffhal auf..."
###########################################
ffhal_params_and_files

# uci set gluon-setup-mode.@setup_mode[0].configured='1'
echo

###########################################
echo "-> frische Netzwerk-Parameter fuer ffhal auf..."
###########################################
echo -n "."; uci set fastd.sample_config.mtu='1426'
echo -n "."; uci set fastd.mesh_vpn.mtu='1426'
echo -n "."; uci set network.mesh_vpn.mtu='1426'
echo -n "."; uci set network.local_node_dev.macaddr='02:dd:9e:0b:50:1c'
echo -n "."; uci set network.local_node.ipaddr='10.62.0.100/16'
echo -n "."; uci set network.local_node.ip6addr='fd0f:8db3:d50a::100/128'
echo -n "."; uci set network.local_node_route6.target='fd0f:8db3:d50a::/64'
echo -n "."; uci set firewall.mesh_respondd_siteprefix.src_ip='fd0f:8db3:d50a::/64'
echo "ok"
uci commit
echo

#240317x ###########################################
#240317x echo "-> frische alfred Dateien auf..."
#240317x ##########################################
#240317x rm -f /etc/rc.d/S99alfred >/dev/null
#240317x rm -f /etc/rc.d/K99alfred >/dev/null
#240317x alfred_files

#240317x if [ "$CONF_MODE" == "" ]
#240317x then
#240317x   /etc/init.d/micrond restart
#240317x   /etc/init.d/alfred restart
#240317x fi

#240317x echo

#240317x ###########################################
#240317x echo "-> frische batman-adv Dateien auf..."
#240317x ###########################################
#240317x batman_files
#240317x echo

##########################################
echo "-> frische Dateien von respondd auf..."
###########################################
respondd_files

if [ "$CONF_MODE" == "" ]
then
  /etc/init.d/gluon-respondd restart
fi

###########################################
# for debug...                            #
###########################################
# echo "21S"; uci set fastd.mesh_vpn.secret='10c0ac0a49bed094c6b1f1eda54fc73efc3c5ff36834028c4dc2ee8ce5414b47'
###########################################

uci commit
echo

###########################################
echo "-> frische WLAN Einstellungen auf..."
###########################################
# uci del wireless.radio0.legacy_rates

echo -n "."; uci del wireless.radio0.supported_rates 2> /dev/null

echo -n "."; uci add_list wireless.radio0.supported_rates='6000'
echo -n "."; uci add_list wireless.radio0.supported_rates='9000'
echo -n "."; uci add_list wireless.radio0.supported_rates='12000'
echo -n "."; uci add_list wireless.radio0.supported_rates='18000'
echo -n "."; uci add_list wireless.radio0.supported_rates='24000'
echo -n "."; uci add_list wireless.radio0.supported_rates='36000'
echo -n "."; uci add_list wireless.radio0.supported_rates='48000'
echo -n "."; uci add_list wireless.radio0.supported_rates='54000'

echo -n "."; uci del wireless.radio0.basic_rate 2> /dev/null

echo -n "."; uci add_list wireless.radio0.basic_rate='6000'
echo -n "."; uci add_list wireless.radio0.basic_rate='9000'
echo -n "."; uci add_list wireless.radio0.basic_rate='18000'
echo -n "."; uci add_list wireless.radio0.basic_rate='36000'
echo -n "."; uci add_list wireless.radio0.basic_rate='54000'

echo -n "."; uci set wireless.radio0.channel='13'
## echo -n "."; uci set wireless.radio0.country='DE'
echo -n "."; uci set wireless.mesh_radio0.mesh_id='02:CA:FF:EE:BA:BE'
echo "ok";   uci set wireless.client_radio0.ssid='www.freifunk-halle.org'
echo

###########################################
echo "-> passe ntp Einstellungen an..."
###########################################
echo -n "."; uci del system.ntp.server 2> /dev/null

#echo -n "."; uci add_list system.ntp.server='time1.service.ffhal'
#echo -n "."; uci add_list system.ntp.server='time2.service.ffhal'
echo -n "."; uci add_list system.ntp.server='fd0f:8db3:d50a:0:208:a1ff:fe25:cf0a'
echo -n "."; uci add_list system.ntp.server='131.188.3.220'
echo -n "."; uci add_list system.ntp.server='131.188.3.221'
echo -n "."; uci add_list system.ntp.server='131.188.3.222'
echo -n "."; uci add_list system.ntp.server='192.53.103.108'
echo "ok";

uci commit
echo

if [ "$CONF_MODE" == "" ]
then
  wifi
fi

###########################################
echo "-> frische LED-Steuerung auf..."
###########################################
echo -n "."; uci set system.led_dsl.sysfs='fritz7312:green:power'
echo -n "."; uci set system.led_dsl.mode='link'

echo "ok"

uci commit

cp -f /tmp/store/led-changer.sh  /usr/libexec
chmod 755 /usr/libexec/led-changer.sh
cp -f /tmp/store/led-changer     /usr/lib/micron.d
chmod 644 /usr/lib/micron.d/led-changer

uci commit

if [ "$CONF_MODE" == "" ]
then
  /etc/init.d/micrond restart   # doesn't run in config mode
  /etc/init.d/led reload
fi

echo

###########################################
echo "-> frische DAC524's Workaround auf..."
###########################################
dac524_files

###########################################
if [ "$CONF_MODE" != "" ]
then
  echo
  echo "Den Router nun bitte jetzt neu starten!"
  echo "Dies laesst sich hier mit dem Kommando reboot erreichen."
else
  echo
  echo "Falls etwas nicht wie erwartet normal funktioniert,"
  echo "bitte die laufenden Dienste ueberpruefen und ggf. neu starten. Im Zweifelsfall hilft reboot ..."
fi
echo
###########################################
